import acrort

CREATE_MY_PROFILE_COMMAND_ID = '4E022031-974B-4081-A37E-FED5E9718746'
ENSURE_MY_PROFILE_COMMAND_ID = '22271ACE-5EE5-483A-B9D3-AA8FBE1E065E'
DELETE_MY_PROFILE_COMMAND_ID = '8AFD2764-401F-49EE-A878-85EB7BC23CE3'
DELETE_PROFILES_COMMAND_ID = 'C8373DDC-237F-41EB-B515-595AFC0232AC'
ADD_TO_MY_PROFILE_COMMAND_ID = '808FE060-FB91-460C-A3D5-1DE9B5FFD6D6'
ADD_TO_PROFILES_COMMAND_ID = 'FB2C2B87-23C3-425E-A915-8A196F4887ED'
DELETE_ENTRIES_COMMAND_ID = '5F6B7A40-4FBA-4DE5-872B-090FB1DC51A3'


def create_my_profile(connection):
    act = connection.tol.launch_command(command=CREATE_MY_PROFILE_COMMAND_ID)
    return connection.tol.get_result(act)


def ensure_my_profile(connection):
    act = connection.tol.launch_command(command=ENSURE_MY_PROFILE_COMMAND_ID)
    return connection.tol.get_result(act)


def delete_my_profile(connection):
    act = connection.tol.launch_command(command=DELETE_MY_PROFILE_COMMAND_ID)
    return connection.tol.get_result(act)


def delete_profile(connection, *, profile_id):
    arg = {'Subjects': [('guid', profile_id)]}
    act = connection.tol.launch_command(command=DELETE_PROFILES_COMMAND_ID, argument=arg)
    return connection.tol.get_result(act)


def add_to_my_profile(connection, *, resource_type, resource_address, user_name, password):
    raw_creds = {'UserName': user_name,
                 'Password': password}

    array_entry = {'ResourceType': ('dword', resource_type),
                   'Address': resource_address,
                   'Credentials': raw_creds}

    arg = {'Entries': [array_entry]}

    act = connection.tol.launch_command(command=ADD_TO_MY_PROFILE_COMMAND_ID, argument=arg)
    return connection.tol.get_result(act)


def add_to_profile(connection, *, profile_id, resource_type, resource_address, user_name, password):
    raw_creds = {'UserName': user_name,
                 'Password': password}

    array_entry = {'ResourceType': ('dword', resource_type),
                   'Address': resource_address,
                   'Credentials': raw_creds}

    arg = {'Entries': [array_entry],
           'Targets': [('guid', profile_id)]}

    act = connection.tol.launch_command(command=ADD_TO_PROFILES_COMMAND_ID, argument=arg)
    return connection.tol.get_result(act)


def delete_profile_entry(connection, *, entry_id):
    arg = {'Entries': [('guid', entry_id)]}
    act = connection.tol.launch_command(command=DELETE_ENTRIES_COMMAND_ID, argument=arg)
    return connection.tol.get_result(act)
