import acrort
from . constants import *


def resolve_local_asz_uri(conn):
    tree = conn.gtob.open_global_tree()
    vaults_root_key = acrort.gtob.ItemKey('PersonalVaults', 'dms:personal_vaults')
    vaults_root = tree.resolve_item(key=vaults_root_key)
    vaults = tree.select_children(key=vaults_root.key)
    for vault in vaults:
        attributes = vault.attributes
        if attributes is None:
            continue
        storage_uri = attributes.get_branch('.Settings.StorageUri', None)
        if storage_uri is None:
            continue
        if storage_uri.ref == TAG_URI_ASZ:
            return attributes.LocationUri.ref
    return None
