"""
@file
@brief    Exception Hook setup tool
@details  Copyright (c) 2001-2013 Acronis
@author   Bulat Gaifullin (bulat.gaifullin@acronis.com)
@since    $$Id: excepthook.py 877296 2013-12-27 18:29:57Z bgaifullin $$
"""

import logging
import sys
import traceback


def exception_hook(exc_t, exc_v, tb):
    if not issubclass(exc_t, (KeyboardInterrupt, SystemExit)):
        logging.error('*** Uncaught exception ***')
        logging.error(''.join(traceback.format_exception(exc_t, exc_v, tb)))


def setup():
    sys.excepthook = exception_hook
