"""
@file
@brief    
@details  Copyright (c) 2001-2013 Acronis
@author   Bulat Gaifullin (bulat.gaifullin@acronis.com)
@since    $$Id: json.py 882789 2014-01-23 07:00:02Z bgaifullin $$
"""

try:
    import ujson as __json
    dumps = __json.dumps
    loads = __json.loads
except ImportError:
    import json as __json

    def _default_encoder(o):
        def _raise_error():
            raise TypeError(repr(o) + ' is not JSON serializable')

        return getattr(o, 'toDict', _raise_error)()

    def dumps(o, **kwargs):
        return __json.dumps(o, default=_default_encoder, **kwargs)

    def loads(s, **kwargs):
        if isinstance(s, bytes):
            s = s.decode('utf8')
        return __json.loads(s, **kwargs)
