"""
@file
@brief    Singleton Pattern implementation
@details  Copyright (c) 2001-2013 Acronis
@author   Bulat Gaifullin (bulat.gaifullin@acronis.com)
@since    $$Id: singleton.py 880061 2014-01-15 06:58:54Z bgaifullin $$
"""


class Singleton(type):
    def __call__(cls, *args, **kwargs):
        if cls.instance is None:
            cls.instance = super(Singleton, cls).__call__(*args, **kwargs)
        return cls.instance

    def __init__(cls, name, bases, methods):
        super(Singleton, cls).__init__(name, bases, methods)
        cls.instance = None
