"""
@file
@brief    
@details  Copyright (c) 2001-2013 Acronis
@author   Bulat Gaifullin (bulat.gaifullin@acronis.com)
@since    $$Id: session.py 910916 2014-04-16 21:10:31Z bgaifullin $$
"""

from . import api
from urllib.request import HTTPCookieProcessor


class Session:
    def __init__(self):
        self.processors = [HTTPCookieProcessor()]

    def delete(self, url, **kwargs):
        return api.delete(url, processors=self.processors, **kwargs)

    def head(self, url, **kwargs):
        return api.head(url, processors=self.processors, **kwargs)

    def get(self, url, **kwargs):
        return api.get(url, processors=self.processors, **kwargs)

    def post(self, url, data=None, **kwargs):
        return api.post(url, data=data, processors=self.processors, **kwargs)

    def put(self, url, data=None, **kwargs):
        return api.put(url, data=data, processors=self.processors, **kwargs)
